#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""-------------------------------------------------------------------------------------------
-- IMPORTS
-------------------------------------------------------------------------------------------"""

""" --- HUEY IMPORT --- """
""" --- PYTHON IMPORTS --- """
""" --- STASHR DEPENDENCY IMPORTS --- """
""" --- STASHR CORE IMPORTS --- """
from stashr import log, database

""" --- FLASK EXTENSION IMPORTS --- """
from flask_wtf import FlaskForm

from wtforms import StringField, BooleanField, SelectField, IntegerField, HiddenField, TextAreaField, SubmitField
from wtforms.validators import DataRequired, Length, Email, EqualTo, ValidationError, NumberRange

""" --- CREATE LOGGER --- """
logger = log.stashr_logger(__name__)

"""-------------------------------------------------------------------------------------------
-- FORMS
-------------------------------------------------------------------------------------------"""

class settings_form(FlaskForm):

    max_width = IntegerField(
        'Max Image Width',
        validators = [
        ]
    )
    quality = IntegerField(
        'Image Quality',
        validators = [
            NumberRange(min=0, max=100, message='Enter a number between 0 and 100')
        ]
    )
    save_original_file = BooleanField(
        'Backup Original Image Files',
        validators = [
        ]
    )
    settings_button = SubmitField(
        'Save',
    )